
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "QmfPackage.h"
#include <qmf/Schema.h>
#include <qmf/SchemaProperty.h>
#include <qmf/SchemaMethod.h>
#include <string>

using namespace std;
using namespace qmf::org::pacemakercloud;

void PackageDefinition::configure(::qmf::AgentSession& session)
{
    string package("org.pacemakercloud");

    //
    // Data: cpe
    //
    data_cpe = qmf::Schema(SCHEMA_TYPE_DATA, package, "cpe");
    {
        qmf::SchemaMethod method("deployable_start");
        method.setDesc("start");
        {
            qmf::SchemaProperty arg("name", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("uuid", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("rc", qmf::SCHEMA_DATA_INT);
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_cpe.addMethod(method);
    }

    {
        qmf::SchemaMethod method("deployable_stop");
        method.setDesc("stop");
        {
            qmf::SchemaProperty arg("name", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("uuid", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("rc", qmf::SCHEMA_DATA_INT);
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_cpe.addMethod(method);
    }

    {
        qmf::SchemaMethod method("deployable_reload");
        method.setDesc("reload");
        {
            qmf::SchemaProperty arg("name", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("uuid", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("rc", qmf::SCHEMA_DATA_INT);
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_cpe.addMethod(method);
    }

    session.registerSchema(data_cpe);

    //
    // Data: dpe
    //
    data_dpe = qmf::Schema(SCHEMA_TYPE_DATA, package, "dpe");
    {
        qmf::SchemaProperty prop("deployables", qmf::SCHEMA_DATA_INT);
        prop.setDesc("numbers of managed deployables");
        data_dpe.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("assemblies", qmf::SCHEMA_DATA_INT);
        prop.setDesc("numbers of managed assemblies");
        data_dpe.addProperty(prop);
    }

    {
        qmf::SchemaMethod method("deployable_load");
        method.setDesc("load");
        {
            qmf::SchemaProperty arg("name", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("uuid", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("rc", qmf::SCHEMA_DATA_INT);
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_dpe.addMethod(method);
    }

    {
        qmf::SchemaMethod method("deployable_unload");
        method.setDesc("unload");
        {
            qmf::SchemaProperty arg("name", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("uuid", qmf::SCHEMA_DATA_STRING);
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("rc", qmf::SCHEMA_DATA_INT);
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_dpe.addMethod(method);
    }

    {
        qmf::SchemaMethod method("deployables_list");
        method.setDesc("List known deployables");
        {
            qmf::SchemaProperty arg("deployables", qmf::SCHEMA_DATA_LIST);
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_dpe.addMethod(method);
    }

    session.registerSchema(data_dpe);

    //
    // Event: deployable_state_change
    //
    event_deployable_state_change = qmf::Schema(SCHEMA_TYPE_EVENT, package, "deployable_state_change");
    event_deployable_state_change.setDefaultSeverity(qmf::SEV_INFORM);
    {
        qmf::SchemaProperty prop("deployable", qmf::SCHEMA_DATA_STRING);
        event_deployable_state_change.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("state", qmf::SCHEMA_DATA_STRING);
        event_deployable_state_change.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("reason", qmf::SCHEMA_DATA_STRING);
        event_deployable_state_change.addProperty(prop);
    }

    session.registerSchema(event_deployable_state_change);

    //
    // Event: assembly_state_change
    //
    event_assembly_state_change = qmf::Schema(SCHEMA_TYPE_EVENT, package, "assembly_state_change");
    event_assembly_state_change.setDefaultSeverity(qmf::SEV_INFORM);
    {
        qmf::SchemaProperty prop("deployable", qmf::SCHEMA_DATA_STRING);
        event_assembly_state_change.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("assembly", qmf::SCHEMA_DATA_STRING);
        event_assembly_state_change.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("state", qmf::SCHEMA_DATA_STRING);
        event_assembly_state_change.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("reason", qmf::SCHEMA_DATA_STRING);
        event_assembly_state_change.addProperty(prop);
    }

    session.registerSchema(event_assembly_state_change);

    //
    // Event: service_state_change
    //
    event_service_state_change = qmf::Schema(SCHEMA_TYPE_EVENT, package, "service_state_change");
    event_service_state_change.setDefaultSeverity(qmf::SEV_INFORM);
    {
        qmf::SchemaProperty prop("deployable", qmf::SCHEMA_DATA_STRING);
        event_service_state_change.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("assembly", qmf::SCHEMA_DATA_STRING);
        event_service_state_change.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("service", qmf::SCHEMA_DATA_STRING);
        event_service_state_change.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("state", qmf::SCHEMA_DATA_STRING);
        event_service_state_change.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("reason", qmf::SCHEMA_DATA_STRING);
        event_service_state_change.addProperty(prop);
    }

    session.registerSchema(event_service_state_change);

}

